function love.load()
	require "functions" --some helper functions

	screen = require "screen" --my own screen module
	
	gamera = require "gamera"
	camera = gamera.new(0, 0, screen.w*2, screen.h*2)
	
	screen:resize(screen.monitor.w/2,screen.monitor.h/2,false,false)
	
	--physics
	love.physics.setMeter(64)
	world = love.physics.newWorld(0, 10*256, true)
	--later this will NOT be here!
	level = {}
		level[1] = {}
			level[1].body = love.physics.newBody(world,screen.w,screen.h+400)
			level[1].shape = love.physics.newRectangleShape(2500,100)
			level[1].fixture = love.physics.newFixture(level[1].body,level[1].shape)
		level[1].body:setAngle(0.38)
		level[1].fixture:setFriction(0.5)
		
		level[2] = {}
		level[2].body = love.physics.newBody(world,screen.w+500,screen.h+600)
			level[2].shape = love.physics.newRectangleShape(1000,100)
			level[2].fixture = love.physics.newFixture(level[2].body,level[2].shape)
		level[2].body:setAngle(0)
		level[2].fixture:setFriction(0.5)
		
		
	player = require "player" --player behaviour
	playerList = {
		player:spawn(), --player 1, playerList[1]
		player:spawn() --player 2, playerList[2]
	}
	--player setup
	playerList[1].body:setPosition(screen.w,screen.h)
	
	playerList[2].body:setPosition(screen.w+100,screen.h)
	playerList[2].color = {255,210,210}
	playerList[2].keys = {}
		playerList[2].keys.jump = "up"
		playerList[2].keys.left = "left"
		playerList[2].keys.down = "down"
		playerList[2].keys.right = "right"
	
	--backgroundcolor
	love.graphics.setBackgroundColor(100,120,110)
end

function love.update(dt)
	love.window.setTitle("Physics testing, fps: "..love.timer.getFPS())--fps debug
	for i,v in ipairs(playerList) do v:update(dt) end
	
	world:update(dt)
	
	--camera follow
	local x,y = 0,0
	for i,v in ipairs(playerList) do x,y = x+v.body:getX(),y+v.body:getY() end
	camera:setPosition(x/#playerList,y/#playerList)
end

function love.draw()
	love.graphics.setCanvas(screen.canvas) --start painting on screen canvas
	--love.graphics.push()
		--canvas background
		love.graphics.setColor(love.graphics.getBackgroundColor())
		love.graphics.rectangle("fill",0,0,screen.w,screen.h)
		
		camera:draw(function(l,t,w,h)
			--box
			love.graphics.setColor(0,0,0)
			love.graphics.setLineWidth(5)
			love.graphics.rectangle("line",10,10,screen.w-20,screen.h-20)
			
			--level
			for i,v in ipairs(level) do love.graphics.setColor(255,255,255) love.graphics.polygon("line",v.body:getWorldPoints(v.shape:getPoints())) end
			--players
			for i,v in ipairs(playerList) do v:draw() end
		end)
	--love.graphics.pop()
	love.graphics.setCanvas() --stop drawing on canvas
	
	--fill background
	love.graphics.setColor(10,12,9)
	love.graphics.rectangle("fill",0,0,screen.w,screen.h)
	
	screen:set()
		--draw screen
		love.graphics.setColor(255,255,255)
		love.graphics.draw(screen.canvas,0,0)
	screen:unset()
end

function love.keypressed(key)
	--jumping
	for i,v in ipairs(playerList) do v:jumpCheck(key) end
	--escape
	if key == "escape" then love.event.push("quit") end
end

function love.resize(w,h)
	screen:stretch(w,h)
end